/*! @file utils.h
 *  @brief Contém as definições e declarações comuns aos modulos.
 *  @details
 *  @author Norberto R. de Goes Jr.
 *  @bug nenhum bug conhecido.
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <signal.h>

#include "commons.h"

extern int  data_size_tx_g;

extern int   server_port_tcp_g;

/** Armazena o identificador do socket inicial. **/
extern int   socket_fd_g;

/** Armazena o endereço ip do servidor (remoto). **/
extern char ip_address_server_g[16];

extern void get_args(int argc, char* argv[]);
extern void open_socket(int* socket_fd, int style, char with_timeout);

extern void* echo_client(void * p_param);

extern char running_g;

/**
 * Estutura para passagem de parâmetros à thread servidora.
 */
typedef struct str {
    int    port;
    int    conn_type;
    int*   p_socket;
} initial_parameters;

